package org.somda.protosdc_converter.converter.kotlin.entrygen

import org.somda.protosdc_converter.converter.kotlin.KotlinEntry
import org.somda.protosdc_converter.converter.kotlin.KotlinSource
import org.somda.protosdc_converter.xmlprocessor.BaseNode
import java.io.ByteArrayOutputStream
import java.io.PrintWriter

/**
 * Code generator for [KotlinEntry.DataClass] type.
 *
 * @param kotlinSource required to produce Kotlin particles.
 * @param entry the entry for which code is generated by this object.
 * @param level code depth on which code is generated (0 for no indentation).
 *              Indentation size is determined by `kotlinSource`
 * @param generateNestedCode generation callback for nested types.
 */
internal class DataClassGen(
    private val kotlinSource: KotlinSource,
    private val entry: KotlinEntry.DataClass,
    private val level: Int,
    private val generateNestedCode: (node: BaseNode, level: Int, target: PrintWriter) -> Unit
) : CodeGenerator {
    override fun enter(): String {
        return kotlinSource.indent(level) {
            kotlinSource.dataClassPrimaryConstructorStart(entry.typeName)
        }
    }

    override fun exit(): String {
        return ByteArrayOutputStream().apply {
            PrintWriter(this).use { printWriter ->
                printWriter.print(kotlinSource.indent(level, kotlinSource::constructorEnd))
                if (entry.nestedTypes.isNotEmpty()) {
                    printWriter.println(kotlinSource.blockStart())
                    entry.nestedTypes.forEach { nestedType ->
                        generateNestedCode(
                            nestedType,
                            level + 1,
                            printWriter
                        )
                    }

                    printWriter.print(kotlinSource.indent(level, kotlinSource::blockEnd))
                }
            }
        }.toString()
    }
}